package com.vcarecity.test.core;

import com.vcarecity.test.typehandler.TypeParam;

import javax.persistence.Column;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Kerry on 19/12/10
 */

public class ReflectionUtil {

    public static <T> List<TypeParam> reflectOrmClass(Class<T> cls) {
        Field[] declaredFields = cls.getDeclaredFields();

        List<TypeParam> list = new ArrayList<>(declaredFields.length);

        for (Field field : declaredFields) {
            final Column column = field.getAnnotation(Column.class);
            String columnName;
            if (column == null) {
                columnName = field.getName();
            } else {
                columnName = column.name();
            }
            final TypeParam typeParam = new TypeParam();
            typeParam.setColumnName(columnName);
            typeParam.setField(field);
            list.add(typeParam);
        }
        return list;

    }

}
