package com.vcarecity.test.repository.impl;


import com.google.inject.Inject;
import com.vcarecity.test.entity.AgencyEntity;
import com.vcarecity.test.repository.AgencyRepository;
import lombok.extern.slf4j.Slf4j;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Kerry on 19/12/10
 */

@Slf4j
public class AgencyRepositoryImpl implements AgencyRepository {

    private final DataSource dataSource;

    @Inject
    public AgencyRepositoryImpl(DataSource dataSource) {
        this.dataSource = dataSource;
    }

    @Override
    public List<AgencyEntity> findByAgencyIdList(List<Integer> agencyIdList) throws SQLException {

        final String join = String.join(",", agencyIdList.stream().map(i -> "" + i).toArray(String[]::new));

        String sql = "select AGENCY_NAME from T_AGENCY where AGENCY_ID in (" + join + ")";

        logger.debug("findByAgencyIdList: {}", sql);

        try (final Connection connection = dataSource.getConnection();
             final Statement statement = connection.createStatement();
             final ResultSet resultSet = statement.executeQuery(sql)) {

            List<AgencyEntity> list = new ArrayList<>();
            while (resultSet.next()) {
                AgencyEntity ae = new AgencyEntity();
                ae.setAgencyName(resultSet.getString("AGENCY_NAME"));
                list.add(ae);
            }
            return list;
        }
    }
}
