package com.vcarecity.publish.controller;

import com.vcarecity.publish.api.ApiResult;
import com.vcarecity.publish.api.ApiStatus;
import com.vcarecity.publish.constants.ElasticConstant;
import com.vcarecity.publish.pojo.dto.UnitAgencyDTO;
import com.vcarecity.publish.pojo.query.UnitAgencyQuery;
import com.vcarecity.publish.sql.service.UnitService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.io.IOException;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author Kerry on 19/12/11
 */

@RestController
public class MainController {

    private final UnitService unitService;

    public MainController(UnitService unitService) {
        this.unitService = unitService;
    }

    @PostMapping("/query-unit-agency")
    public ApiResult queryUnitAgency(@RequestBody @Valid UnitAgencyQuery unitAgencyQuery) throws IOException {
        final List<UnitAgencyDTO> unitAgencyByQuery = unitService.getUnitAgencyByQuery(unitAgencyQuery.getAgencyPath(), unitAgencyQuery.getKeyword(),
                unitAgencyQuery.getPage(), unitAgencyQuery.getSize(), ElasticConstant.UNIT_AGENCY_INDEX);
        List<Long> data = unitAgencyByQuery.stream().map(UnitAgencyDTO::getUnitId).collect(Collectors.toList());
        return ApiResult.builder().status(ApiStatus.SUCCESS_CODE).data(data).build();
    }

    @PostMapping("/test/query-unit-agency")
    public ApiResult testQueryUnitAgency(@RequestBody @Valid UnitAgencyQuery unitAgencyQuery) throws IOException {
        List<UnitAgencyDTO> data = unitService.getUnitAgencyByQuery(unitAgencyQuery.getAgencyPath(), unitAgencyQuery.getKeyword(),
                unitAgencyQuery.getPage(), unitAgencyQuery.getSize(), ElasticConstant.UNIT_AGENCY_INDEX);
        return ApiResult.builder().status(ApiStatus.SUCCESS_CODE).data(data).build();
    }


}
